| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::DistanceLodBoxStrategy Class Reference
Core » LOD

Level of detail strategy based on distance from camera to an object's bounding box. More...

`#include <OgreDistanceLodStrategy.h>`

Inheritance diagram for Ogre::DistanceLodBoxStrategy:
[legend]

## Public Member Functions
| DistanceLodBoxStrategy ()
| Default constructor. More...
void | assertSorted (const Mesh::LodValueList &values) const
| Assert that the LOD values are sorted from greatest detail to least detail. More...
virtual Real | getBaseValue () const
| Get the value of the first (highest) level of detail. More...
virtual ushort | getIndex (Real value, const Mesh::MeshLodUsageList &meshLodUsageList) const
| Get the index of the LOD usage which applies to a given value. More...
virtual ushort | getIndex (Real value, const Material::LodValueList &materialLodValueList) const
| Get the index of the LOD usage which applies to a given value. More...
const String & | getName () const
| Get the name of this strategy. More...
Real | getSquaredDepth (const MovableObject *movableObject, const Ogre::Camera *camera) const
| Get the squared depth from camera to the LOD object. More...
Real | getValue (const MovableObject *movableObject, const Camera *camera) const
| Compute the LOD value for a given movable object relative to a given camera. More...
bool | isReferenceViewEnabled () const
| Determine if use of the reference view is enabled. More...
virtual bool | isSorted (const Mesh::LodValueList &values) const
| Determine if the LOD values are sorted from greatest detail to least detail. More...
void | setReferenceView (Real viewportWidth, Real viewportHeight, Radian fovY)
| Sets the reference view upon which the distances were based. More...
void | setReferenceViewEnabled (bool value)
| Enables to disables use of the reference view. More...
virtual void | sort (Mesh::MeshLodUsageList &meshLodUsageList) const
| Sort mesh LOD usage list from greatest to least detail. More...
virtual Real | transformBias (Real factor) const
| Transform LOD bias so it only needs to be multiplied by the LOD value. More...
virtual Real | transformUserValue (Real userValue) const
| Transform user supplied value to internal value. More...

## Static Public Member Functions
static DistanceLodBoxStrategy & | getSingleton (void)
| Get the singleton instance. More...
static DistanceLodBoxStrategy * | getSingletonPtr (void)
| Get the singleton instance. More...

## Detailed Description

Level of detail strategy based on distance from camera to an object's bounding box.

Remarks
  The purpose of the reference view is to ensure a consistent experience for all users. Monitors of different resolutions and aspect ratios will each have different results for the distance queries.

  It depends on gameplay testing. If all testers had 16:9 monitors and 110° FOV, then that's the value you should enter (to ensure as much as possible the experience stays consistent for all other users who don't have a 16:9 monitor and/or use a different FOV).

  If all your testers had 4:3 monitors, then enter a 4:3 resolution.

  If all your testers had varying resolutions or you just didn't care, then this feature is useless for you and should be disabled (default: disabled).

## Constructor & Destructor Documentation

## ◆ DistanceLodBoxStrategy()

Ogre::DistanceLodBoxStrategy::DistanceLodBoxStrategy | ( |  | ) |

Default constructor.

## Member Function Documentation

## ◆ getSquaredDepth()

Real Ogre::DistanceLodBoxStrategy::getSquaredDepth | ( | const MovableObject * | movableObject,
|  | const Ogre::Camera * | camera
| ) |  | const
| virtual

Get the squared depth from camera to the LOD object.

Implements Ogre::DistanceLodStrategyBase.

## ◆ getSingleton()

static DistanceLodBoxStrategy& Ogre::DistanceLodBoxStrategy::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

## ◆ getSingletonPtr()

static DistanceLodBoxStrategy* Ogre::DistanceLodBoxStrategy::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

## ◆ getBaseValue()

virtual Real Ogre::DistanceLodStrategyBase::getBaseValue | ( |  | ) | const
| virtual inherited

Get the value of the first (highest) level of detail.

Implements Ogre::LodStrategy.

## ◆ transformBias()

virtual Real Ogre::DistanceLodStrategyBase::transformBias | ( | Real | factor | ) | const
| virtual inherited

Transform LOD bias so it only needs to be multiplied by the LOD value.

Implements Ogre::LodStrategy.

## ◆ transformUserValue()

virtual Real Ogre::DistanceLodStrategyBase::transformUserValue | ( | Real | userValue | ) | const
| virtual inherited

Transform user supplied value to internal value.

Remarks
  By default, performs no transformation.
  Do not throw exceptions for invalid values here, as the LOD strategy may be changed such that the values become valid.

Reimplemented from Ogre::LodStrategy.

## ◆ getIndex() [1/2]

virtual ushort Ogre::DistanceLodStrategyBase::getIndex | ( | Real | value,
|  | const Mesh::MeshLodUsageList & | meshLodUsageList
| ) |  | const
| virtual inherited

Get the index of the LOD usage which applies to a given value.

Implements Ogre::LodStrategy.

## ◆ getIndex() [2/2]

virtual ushort Ogre::DistanceLodStrategyBase::getIndex | ( | Real | value,
|  | const Material::LodValueList & | materialLodValueList
| ) |  | const
| virtual inherited

Get the index of the LOD usage which applies to a given value.

Implements Ogre::LodStrategy.

## ◆ sort()

virtual void Ogre::DistanceLodStrategyBase::sort | ( | Mesh::MeshLodUsageList & | meshLodUsageList | ) | const
| virtual inherited

Sort mesh LOD usage list from greatest to least detail.

Implements Ogre::LodStrategy.

## ◆ isSorted()

virtual bool Ogre::DistanceLodStrategyBase::isSorted | ( | const Mesh::LodValueList & | values | ) | const
| virtual inherited

Determine if the LOD values are sorted from greatest detail to least detail.

Implements Ogre::LodStrategy.

## ◆ setReferenceView()

void Ogre::DistanceLodStrategyBase::setReferenceView | ( | Real | viewportWidth,
|  | Real | viewportHeight,
|  | Radian | fovY
| ) |  |
| inherited

Sets the reference view upon which the distances were based.

Note
  This automatically enables use of the reference view.
  There is no corresponding get method for these values as they are not saved, but used to compute a reference value.

## ◆ setReferenceViewEnabled()

void Ogre::DistanceLodStrategyBase::setReferenceViewEnabled | ( | bool | value | ) |
| inherited

Enables to disables use of the reference view.

Note
  Do not enable use of the reference view before setting it.

## ◆ isReferenceViewEnabled()

bool Ogre::DistanceLodStrategyBase::isReferenceViewEnabled | ( |  | ) | const
| inherited

Determine if use of the reference view is enabled.

## ◆ getValue()

Real Ogre::LodStrategy::getValue | ( | const MovableObject * | movableObject,
|  | const Camera * | camera
| ) |  | const
| inherited

Compute the LOD value for a given movable object relative to a given camera.

## ◆ assertSorted()

void Ogre::LodStrategy::assertSorted | ( | const Mesh::LodValueList & | values | ) | const
| inherited

Assert that the LOD values are sorted from greatest detail to least detail.

## ◆ getName()

const String& Ogre::LodStrategy::getName | ( | void |  | ) | const
| inline inherited

Get the name of this strategy.

The documentation for this class was generated from the following file:

- OgreDistanceLodStrategy.h